﻿
using System;
using System.ComponentModel;
using System.IO;
using Styx.Helpers;
using Styx.WoWInternals.WoWObjects;

using DefaultValue = Styx.Helpers.DefaultValueAttribute;

namespace Singular.Settings
{
    internal class HunterSettings : Styx.Helpers.Settings
    {
        public HunterSettings()
            : base(Path.Combine(SingularSettings.SingularSettingsPath, "Hunter.xml"))
        {
        }

        #region Category: Pet

        [Setting]
        [DefaultValue(1)]
        [Category("宠物")]
        [DisplayName("召唤宠物序列( 1 到 5 )")]
        public int PetNumberSolo { get; set; }

        [Setting]
        [DefaultValue(1)]
        [Category("宠物")]
        [DisplayName("(PvP)召唤宠物序列( 1 到 5 )")]
        public int PetNumberPvp { get; set; }

        [Setting]
        [DefaultValue(1)]
        [Category("宠物")]
        [DisplayName("(团队)召唤宠物序列( 1 到 5 )")]
        public int PetNumberInstance { get; set; }

        [Setting]
        [DefaultValue(70)]
        [Category("宠物")]
        [DisplayName("治疗宠物，生命 %")]
        public double MendPetPercent { get; set; }

        #endregion

        #region Category: Common

        [Setting]
        [DefaultValue(true)]
        [Category("一般")]
        [DisplayName("使用逃脱")]
        [Description("无论这里如何设置，在战场中都会使用该技能")]
        public bool UseDisengage { get; set; }

        [Setting]
        [DefaultValue(true)]
        [Category("一般")]
        [DisplayName("使用拾回")]
        [Description("将总是使用拾回来捡取离你10码以外的物品")]
        public bool UseFetch { get; set; }

        [Setting]
        [DefaultValue(true)]
        [Category("一般")]
        [DisplayName("团队中使用误导")]
        [Description("团队中在开怪后对tank使用误导, 当所有tank阵亡且猎人获得当前仇恨时对宠物使用误导")]
        public bool UseMisdirectionInInstances { get; set; }

        [Setting]
        [DefaultValue(false)]
        [Category("一般")]
        [DisplayName("蜘蛛毒刺")]
        [Description("True: 在敌人身上维持此技能效果; False: 不使用该技能.")]
        public bool UseWidowVenom { get; set; }

        [Setting]
        [DefaultValue(false)]
        [Category("控制技能")]
        [DisplayName("对焦点目标使用控制技能")]
        [Description("True: 仅对焦点目标使用控制技能; False: 对所有意外加入战斗的目标使用")]
        public bool CrowdControlFocus { get; set; }

        [Setting]
        [DefaultValue(50)]
        [Category("一般")]
        [DisplayName("威慑，生命 %")]
        [Description("战斗中低于设置的生命百分比时使用威慑")]
        public int DeterrenceHealth { get; set; }

        [Setting]
        [DefaultValue(3)]
        [Category("一般")]
        [DisplayName("威慑，敌人数量")]
        [Description("正在攻击猎人的敌人数量 (宠物不计算在内)")]
        public int DeterrenceCount { get; set; }

        [Setting]
        [DefaultValue(10)]
        [Category("一般")]
        [DisplayName("假死，生命 %")]
        [Description("低于设置的生命百分比时使用假死")]
        public int FeignDeathHealth { get; set; }

        [Setting]
        [DefaultValue(true)]
        [Category("一般")]
        [DisplayName("假死清空敌人宝宝的仇恨")]
        [Description("冷却一好就使用假死，当被敌对玩家的宠物攻击时")]
        public bool FeignDeathPvpEnemyPets { get; set; }

        [Setting]
        [DefaultValue(true)]
        [Category("一般")]
        [DisplayName("在队伍里使用假死")]
        [Description("使用假死清空仇恨值如果在战斗时被敌对怪物选中; 不再试图去存活下来。")]
        public bool FeignDeathInInstances { get; set; }

       
        #endregion
    }
}