﻿
using System.ComponentModel;
using System.IO;
using Styx.Helpers;

using DefaultValue = Styx.Helpers.DefaultValueAttribute;
using System.Collections.Generic;

using System.Xml.Serialization;
// using System.IO;
// using System.Reflection;

namespace Singular.Settings
{
    public enum MageArmor
    {
        None = 0,
        Auto = 1,
        Frost,
        Mage,
        Molten
    }

    internal class MageSettings : Styx.Helpers.Settings
    {
        public MageSettings()
            : base(Path.Combine(SingularSettings.SingularSettingsPath, "Mage.xml"))
        {
            // bit of a hack -- SavedToFile setting tracks if we have ever saved
            // .. these settings.  this is needed because we can't use the DefaultValue
            // .. attribute for a multi values setting
            if (!SavedToFile)
            {
                SavedToFile = true;
            }
        }


        // hidden setting to track if we have ever saved this settings file before
        [Setting]
        [Browsable(false)]
        [DefaultValue(false)]
        public bool SavedToFile { get; set; }

        #region Category: Common

        [Setting]
        [Styx.Helpers.DefaultValue(true)]
        [Category("一般")]
        [DisplayName("在队伍中召唤餐桌")]
        [Description("在队伍中使用召唤餐桌来代替制造食物")]
        public bool SummonTableIfInParty { get; set; }

        [Setting]
        [DefaultValue(false)]
        [Category("一般")]
        [DisplayName("使用操控时间")]
        [Description("在适当的时候使用操控时间 (移动功能禁用时不会使用该技能)")]
        public bool UseTimeWarp { get; set; }

        [Setting]
        [DefaultValue(MageArmor.Auto)]
        [Category("一般")]
        [DisplayName("护甲增益")]
        [Description("释放何种护甲 (None: 玩家控制, Auto: 最佳选择)")]
        public MageArmor Armor { get; set; }

        [Setting]
        [DefaultValue(true)]
        [Category("一般")]
        [DisplayName("使用缓落术")]
        [Description("True: 坠落时使用缓落术")]
        public bool UseSlowFall { get; set; }


        #endregion

    }
}
